
-- sp_helpindex 'dbo.orders'

-- No appropriate index
-- TOP N Sort (all rows input)
SELECT customerid, requireddate, orderid
FROM orders
ORDER BY customerid, requireddate 
    OFFSET 400 ROWS
    FETCH NEXT 10 ROWS ONLY;

-- define covering index
CREATE INDEX itemp ON orders(customerid, requireddate) 

-- index scan
SELECT customerid, requireddate, orderid
FROM orders
ORDER BY customerid, requireddate 
    OFFSET 400 ROWS
    FETCH NEXT 10 ROWS ONLY;

UPDATE STATISTICS orders WITH ROWCOUNT = 100000, PAGECOUNT = 10000
GO

-- Now it does key lookup, but before the top clause
-- 801 key lookups required
SELECT customerid, requireddate, employeeid
FROM orders
ORDER BY customerid, requireddate 
    OFFSET 800 ROWS
    FETCH NEXT 1 ROWS ONLY;

-- Now it does key lookup after the top clause
WITH Keys as 
(
SELECT orderid
FROM orders
ORDER BY customerid, requireddate 
    OFFSET 800 ROWS
    FETCH NEXT 1 ROWS ONLY
) 
SELECT K.*, O.*
FROM Keys AS K
CROSS APPLY (
SELECT customerid, requireddate, employeeid
FROM orders as a
WHERE a.orderid = k.orderid
) AS O
ORDER BY customerid, requireddate

WITH Keys as 
(
SELECT orderid
FROM orders
ORDER BY customerid, requireddate 
    OFFSET 20 ROWS
    FETCH NEXT 1 ROWS ONLY
) 
SELECT K.*, O.*
FROM Keys AS K
CROSS APPLY (
SELECT customerid, requireddate, employeeid
FROM orders as a
WHERE a.orderid = k.orderid
) AS O
ORDER BY customerid, requireddate

-- change the table back
UPDATE STATISTICS orders;
DROP INDEX itemp on orders;
GO





